/*
 * Created on 2005. 6. 7
 */
package info.jinwoomin.nevernaver;

import java.io.File;
import java.util.ResourceBundle;

import info.jinwoomin.downloader.SingleDownloader;
import info.jinwoomin.downloader.html.DefaultHtmlDownloader;
import info.jinwoomin.log.AbstractLogabble;

/**
 * @author <a href="mailto:yeoupooh@gmail.com">Jinwoo, Min </a>
 */
public class NeverNaver extends AbstractLogabble
{
    private ResourceBundle bundle;
    private String outputFolder;
    private NaverBlogPage page;
    private int startPage;
    private int endPage;

    public NeverNaver()
    {
    }

    /**
     * @return Returns the outputFolder.
     */
    public String getOutputFolder()
    {
        return outputFolder;
    }

    /**
     * @param outputFolder
     *            The outputFolder to set.
     */
    public void setOutputFolder(String outputFolder)
    {
        this.outputFolder = outputFolder;
    }

    /**
     * @param endPage
     *            The endPage to set.
     */
    public void setEndPage(int endPage)
    {
        this.endPage = endPage;
    }

    /**
     * @param startPage
     *            The startPage to set.
     */
    public void setStartPage(int startPage)
    {
        this.startPage = startPage;
    }

    public void showUsage()
    {
        System.out
                .println("NeverNaver <userId> <category> <startPage> <endPage>");
    }

    public void run(String[] args)
    {
        if (args.length != 4)
        {
            showUsage();
            return;
        }

        bundle = ResourceBundle.getBundle("nevernaver");
        setOutputFolder(bundle.getString("output.folder"));

        page = new NaverBlogPage();
        page.setUserId(args[0]);
        page.setCategory(new Integer(args[1]).intValue());

        setStartPage(new Integer(args[2]).intValue());
        setEndPage(new Integer(args[3]).intValue());

        // make output folder
        File file = new File(outputFolder);
        file.mkdir();

        page.setBundle(this.bundle);
        page.setDownloader(new SingleDownloader());
        page.setHtmlDownloader(new DefaultHtmlDownloader(page));

        logger.info("NeverNaver started.");

        for (int i = startPage; i <= endPage; i++)
        {
            page.setOutputFolder(outputFolder);
            page.setPageIndex(i);
            page.backup();
        }

        logger.info("NeverNaver done.");
    }

    public static void main(String[] args)
    {
        NeverNaver app = new NeverNaver();
        app.run(args);
    }
}
